'**************************************************************************
'*                              E30DEMO.MST      : Based on MSSetup Toolkit Sample 2
'**************************************************************************

''$DEFINE DEBUG  ''Define for script development/debugging
'$DEFINE DEMO		'' Define for demo file installation

'$INCLUDE 'setupapi.inc'
'$INCLUDE 'msdetect.inc'

''Dialog ID's
CONST WELCOME           = 100
CONST ASKQUIT           = 200
CONST DESTPATH          = 300
CONST EXITFAILURE       = 400
CONST EXITQUIT          = 600
CONST EXITSUCCESS       = 700
CONST OPTIONS           = 800
CONST APPHELP           = 900
CONST TT_WARNING		= 2000
CONST PPDRV_WARNING		= 2200
CONST TYP1_WARNING		= 2100
CONST TT_INSTALLMSG		= 2300
CONST FONTPATH          = 4200
CONST SAMPLELIST        = 5200
CONST CUSTINST          = 6200
CONST TOOBIG            = 6300
CONST BADPATH           = 6400
CONST ALREADYUSED		= 7100
CONST CONFIRMINFO       = 7300
CONST GETNAMEORG        = 7500
CONST BADNAME			= 7700
CONST MR_WELCOME		= 8000
CONST MR_CUSTINST 		= 8100

''Bitmap ID
CONST LOGO         = 1

''File Types
CONST PROG_FILES        = 1
CONST DVC_FILES                 = 2
CONST SMPL_FILES                = 3
CONST TT_FILES                  = 4
CONST TYP1_FILES                = 5
CONST PPDRV_FILES				= 6

GLOBAL DEST$        ''Default destination directory.
GLOBAL WINDRIVE$    ''Windows drive letter.
GLOBAL WINSYS$          '' Windows System Directory
GLOBAL SMPL_OPT$        '' List of Sample files to install
GLOBAL TYP1_DEST$       '' Destination for Type 1 fonts

GLOBAL ALL_SMPL_OPT$    '' All Sample Files

''CustInst list symbol names
GLOBAL PROG_NEEDS$    ''Option list costs per drive
GLOBAL DVC_NEEDS$
GLOBAL SMPL_NEEDS$
GLOBAL TT_NEEDS$                
GLOBAL TYP1_NEEDS$
GLOBAL PPDRV_NEEDS$

'' GetNameOrg  list symbol names
GLOBAL NAMEORGIN$
GLOBAL NAMEORGOUT$
GLOBAL CONFIRM$
GLOBAL OrigSerial$
GLOBAL AlreadyInstalled%
GLOBAL ItsAMiracle%

GLOBAL EXTRACOSTS$  ''List of extra costs to add per drive
GLOBAL BIGLIST$     ''List of option files cost calc results (boolean)

''Dialog list symbol names
GLOBAL CHECKSTATES$
GLOBAL GREYSTATE$
GLOBAL STATUSTEXT$
GLOBAL DRIVETEXT$


DECLARE SUB AddOptFilesToCopyList (ftype%)
DECLARE SUB RecalcOptFiles (ftype%)
DECLARE SUB RecalcPath
DECLARE SUB SetDriveStatus
DECLARE FUNCTION MakePath (szDir$, szFile$) AS STRING
DECLARE FUNCTION ValidSerialNo( szSerial$ ) AS INTEGER
DECLARE FUNCTION IsWriteProtected( ) AS INTEGER

'' Functions in DLL
DECLARE FUNCTION GetCurrentInfo LIB "mscuistf.dll" ( DoDir% ) AS INTEGER
INIT:

    CUIDLL$ = "mscuistf.dll"            ''custom user interface dll
    HELPPROC$ = "FHelpDlgProc"          ''Help dialog procedure
    WINDRIVE$ = MID$(GetWindowsDir, 1, 1)

    SetBitmap CUIDLL$, LOGO

'$IFDEF DEMO
    DEST$ = WINDRIVE$ + ":\E30DEMO"
    SetTitle "Encore 3.0 Demo Setup"
'$ELSE
    DEST$ = WINDRIVE$ + ":\ENCORE30"
    SetTitle "Encore 3.0 Setup"
'$ENDIF

	TYP1_DEST$ = WINDRIVE$ + ":\PSFONTS"

    szInf$ = GetSymbolValue("STF_SRCINFPATH")
    IF szInf$ = "" THEN
		szInf$ = GetSymbolValue("STF_CWDDIR") + "E3SETUP.INF"
    END IF
    ReadInfFile szInf$

	'' Check if we are installing the miracle drivers...
	IF INSTR( UCASE$( szInf$ ), "MIRACLE.INF" ) THEN
		ItsAMiracle% = 1
	ELSE
		ItsAMiracle% = 0
	END IF

    ''CustInst list symbols
    CHECKSTATES$ = "CheckItemsState"
    STATUSTEXT$  = "StatusItemsText"
    DRIVETEXT$   = "DriveStatusText"

    FOR i% = 1 TO 6 STEP 1
		AddListItem CHECKSTATES$, "ON"
		AddListItem STATUSTEXT$, ""
    NEXT i%
	'' Initially, don't install Type 1 fonts
	ReplaceListItem CHECKSTATES$, 5, ""

	FOR i% = 1 TO 8 STEP 1
		AddListItem DRIVETEXT$, ""
	NEXT i%         

    ReplaceListItem DRIVETEXT$, 7, DEST$
	ReplaceListItem DRIVETEXT$, 8, TYP1_DEST$

    ''Disk cost list symbols
    PROG_NEEDS$   = "ProgNeeds"
	DVC_NEEDS$      = "DvcNeeds"
	SMPL_NEEDS$     = "SmplNeeds"
	TT_NEEDS$       = "TTNeeds"     
	TYP1_NEEDS$     = "Type1Needs"
	PPDRV_NEEDS$	= "PpDrvNeeds"

	EXTRACOSTS$ = "ExtraCosts"
    BIGLIST$    = "BigList"

    FOR i% = 1 TO 6 STEP 1
		AddListItem BIGLIST$, ""
    NEXT i%

	'' NOTE: This might vary depending on the number of files
    FOR i% = 1 TO 26 STEP 1
		AddListItem EXTRACOSTS$, "0"
    NEXT i%


	ALL_SMPL_OPT$ = "ListItemsIn"
	SMPL_OPT$ = "ListItemsOut"
	MakeListFromSectionKeys  SMPL_OPT$, "SampleFiles"	'' init to ALL Sample Files

	'' Symbols for NameOrg
	NAMEORGIN$ = "NameOrgIn"
	NAMEORGOUT$ = "NameOrgOut"
	CONFIRM$ = "ConfirmTextIn"
	FOR i% = 1 TO 3 STEP 1
		AddListItem NAMEORGIN$, ""
		AddListItem NAMEORGOUT$, ""
		AddListItem CONFIRM$, ""
	NEXT i%
	AddListItem NAMEORGIN$, ""      '' Extra place for disk volume name
	'' The Serial Number Stuff
	OrigSerial$ = ""
	AlreadyInstalled% = 0

    RecalcPath
    SetDriveStatus

'$IFDEF DEBUG
    i% = SetSizeCheckMode(scmOnIgnore)    '' could use scmOff; def = scmOnFatal
'$ENDIF ''DEBUG

WELCOME:
'$IFDEF DEMO
	x% = DoMsgBox( "Welcome to Encore 3.0 Demo Setup!", "Encore 3.0 Demo Setup", 0 )
	GOTO CUSTINST
'$ENDIF
	IF ItsAMiracle% THEN
		sz$ = UIStartDlg( CUIDLL$, MR_WELCOME, "FInfoDlgProc", APPHELP, HELPPROC$ )
	ELSE
		sz$ = UIStartDlg( CUIDLL$, WELCOME, "FInfoDlgProc", APPHELP, HELPPROC$ )
	END IF
	
	IF sz$ = "EXIT" THEN 
		GOSUB ASKQUIT
		GOTO WELCOME
	ELSE
		UIPop 1
	END IF

''-------------------------------------------------------------------------
''	This section gets and/or verifies user info
''-------------------------------------------------------------------------

GETUSERNAME:
	ReplaceListItem NAMEORGIN$, 4, DEST$ 
	'' Don't ask for the directory date just yet.
	ok% = GetCurrentInfo( 0 )

'$IFDEF DEBUG
	x% = DoMsgBox( "GetCurrentInfo() returns: " + STR$(ok%), "DEBUG", 1 )
	norg% =  GetListLength( NAMEORGIN$ )
	x% = DoMsgBox( "NAMEORGIN$ Len: " + STR$(norg%), "DEBUG", 1 )

	FOR i% = 1 TO norg% STEP 1
		sz$ = GetListItem( NAMEORGIN$, i% )
		x% = DoMsgBox( "NAMEORGIN$ (" + STR$( i% ) + "): " + sz$, "DEBUG", 1 )
	NEXT i%
'$ENDIF ''DEBUG

	OrigName$ = GetListItem( NAMEORGIN$, 1 )

	IF ok% <> 1 OR MID$( OrigName$, 48, 11 ) = "Uninstalled" THEN
		ReplaceListItem NAMEORGIN$, 1, ""
		ReplaceListItem NAMEORGIN$, 2, ""
		OrigSerial$ = ""
		AlreadyInstalled% = 0
	ELSE
		OrigSerial$ = GetListItem(NAMEORGIN$, 3)
		AlreadyInstalled% = -1
	END IF

	'' Clear out the Serial Number
	ReplaceListItem NAMEORGIN$, 3, ""

	OrigName$ = ""

	IF AlreadyInstalled THEN
		ReplaceListItem CONFIRM$, 1, GetListItem( NAMEORGIN$, 1 )
		ReplaceListItem CONFIRM$, 2, GetListItem( NAMEORGIN$, 2 )
		sz$ = UIStartDlg( CUIDLL$, ALREADYUSED, "FConfirmDlgProc", APPHELP, HELPPROC$ )
		IF sz$ = "CONTINUE" THEN 
			UIPop 1
		ELSEIF sz$ = "EXIT" THEN
			UIPop 1
			GOSUB ASKQUIT
		END IF
		ReplaceListItem CONFIRM$, 1, ""
		ReplaceListItem CONFIRM$, 2, ""
	END IF

GETUSERNAMEL1:
	sz$ = UIStartDlg( CUIDLL$, GETNAMEORG, "FNameOrgDlgProc", APPHELP, HELPPROC$ )

	IF sz$ = "CONTINUE" THEN
		FOR i% = 1 TO 2 STEP 1
			ReplaceListItem NAMEORGIN$, i%, GetListItem( NAMEORGOUT$, i% ) 
		NEXT i%
	
		'' User must enter SOMEthing		
		IF GetListItem( NAMEORGOUT$, 1 ) = "" THEN
			sz1$ = UIStartDlg( CUIDLL$, BADNAME, "FInfoDlgProc", 0, "" )
			UIPop 1
			GOTO GETUSERNAMEL1
		END IF

		Serial$ = UCASE$( GetListItem( NAMEORGOUT$, 3 ) )
		ReplaceListItem NAMEORGIN$, 3, Serial$

		IF ValidSerialNo( Serial$ ) = 0 THEN
			GOSUB BADSERIAL
			GOTO GETUSERNAMEL1
		END IF

		UIPop 1

	ELSEIF sz$ = "BACK" THEN
		UIPop 1
		GOTO WELCOME
    ELSEIF sz$ = "REACTIVATE" THEN
	GOTO GETUSERNAMEL1
	ELSE
		GOSUB ASKQUIT
		GOTO GETUSERNAMEL1
	END IF

'' Check to  see that disk isn't write protected

	ON ERROR GOTO WRITEPROTERR

	IF IsWriteProtected () THEN
		x% = DoMsgBox( "Please make sure that " + GetSymbolValue( "STF_SRCDIR" ) + " is NOT Write Protected.", "Encore Setup", 16 )
		ON ERROR GOTO QUIT
		GOTO GETUSERNAMEL1
	ELSE
		ON ERROR GOTO QUIT
		GOTO CONFIRMINFO
	END IF

WRITEPROTERR:
	RESUME NEXT
	
'' Call confirmation dialog here
CONFIRMINFO:
	FOR i% = 1 TO 2 STEP 1
		ReplaceListItem CONFIRM$, i%, GetListItem( NAMEORGOUT$, i% )
	NEXT i%
	ReplaceListItem CONFIRM$, 3, UCASE$( GetListItem( NAMEORGOUT$, i% ) )

CONFIRMINFOL1:
	sz$ = UIStartDlg( CUIDLL$, CONFIRMINFO, "FConfirmDlgProc", APPHELP, HELPPROC$ )
	UIPop 1
	IF sz$ <> "CONTINUE" THEN 
		GOTO GETUSERNAMEL1
	END IF

	'' Stamp Resources in CUIDLL for future installations
	szName$ = GetListItem( CONFIRM$, 1 )
	szOrg$ = GetListItem( CONFIRM$, 2 )
	szSerial$ = GetListItem( CONFIRM$, 3 )
	szDat$ = CHR$( LEN(szName$) ) + szName$ + CHR$( LEN(szOrg$) ) + szOrg$ + CHR$( LEN(szSerial$) ) + szSerial$

'$IFDEF DEBUG
	x% = DoMsgBox( "NameOrgStamp: " + szDat$, "DEBUG", 1 )
'$ENDIF

	SrcDir$ = GetSymbolValue("STF_SRCDIR")
	StampResource "Files", "CUIDLL", SrcDir$, 6, &H471, szDat$, LEN( szDat$ )
	SrcDir$ = ""
	szName$ = ""
	szOrg$ = ""
	szSerial$ = ""
	szDat$ = ""

''-------------------------------------------------------
''	User install options dialog
CUSTINST:
	IF ItsAMiracle% THEN
	    sz$ = UIStartDlg(CUIDLL$, MR_CUSTINST, "FCustInstDlgProc", APPHELP, HELPPROC$)
	ELSE
	    sz$ = UIStartDlg(CUIDLL$, CUSTINST, "FCustInstDlgProc", APPHELP, HELPPROC$)
	END IF

    IF sz$ = "CONTINUE" THEN
		''Install only if it will fit.
		FOR i% = 1 TO 6 STEP 1
		    IF GetListItem(BIGLIST$, i%) <> "" THEN
				GOSUB TOOBIG
				GOTO CUSTINST
	    	END IF
		NEXT i%
		GOTO INSTALL
    ELSEIF sz$ = "PATH" THEN
		GOTO GETPATH
    ELSEIF sz$ = "CHK1" THEN
		RecalcOptFiles PROG_FILES
		SetDriveStatus
		GOTO CUSTINST
    ELSEIF sz$ = "CHK2" THEN
		RecalcOptFiles DVC_FILES
		SetDriveStatus
		GOTO CUSTINST
    ELSEIF sz$ = "CHK3" THEN
		RecalcOptFiles SMPL_FILES
		SetDriveStatus
		GOTO CUSTINST
	ELSEIF sz$ = "CHK4" THEN
		RecalcOptFiles TT_FILES
		SetDriveStatus
		GOTO CUSTINST
    ELSEIF sz$ = "CHK5" THEN
		RecalcOptFiles TYP1_FILES
		SetDriveStatus
		GOTO CUSTINST
	ELSEIF sz$ = "CHK6" THEN
		RecalcOptFiles PPDRV_FILES
		SetDriveStatus
		GOTO CUSTINST
    ELSEIF sz$ = "BTN1" THEN
		GOTO SAMPLEFILES
	ELSEIF sz$ = "BTN2" THEN
		GOTO TYPE1PATH
    ELSEIF sz$ = "REACTIVATE" THEN
		RecalcPath
		SetDriveStatus
		GOTO CUSTINST
    ELSE
		GOSUB ASKQUIT
		GOTO CUSTINST
    END IF


'' ---------------------------------------------
'' This is the actual installation 
'' ---------------------------------------------
INSTALL:

	'' --------------------------------------------------
	'' Warn user about the TrueType fonts

	IF GetListItem( CHECKSTATES$, TT_FILES ) = "ON" THEN
		sz$ = UIStartDlg(CUIDLL$, TT_INSTALLMSG, "FInfoDlgProc", APPHELP, HELPPROC$)
		IF sz$ = "BACK" THEN
			UIPop 1
			GOTO CUSTINST
		ELSEIF sz$ = "EXIT" THEN
			UIPop 1
			GOSUB ASKQUIT
			GOTO CUSTINST
		ELSE
			UIPop 1
		END IF
	ELSE
		sz$ = UIStartDlg(CUIDLL$, TT_WARNING, "FInfoDlgProc", APPHELP, HELPPROC$)
		IF sz$ = "BACK" THEN
			UIPop 1
			GOTO CUSTINST
		ELSEIF sz$ = "EXIT" THEN
			UIPop 1
			GOSUB ASKQUIT
			GOTO CUSTINST
		ELSE
			UIPop 1
		END IF
	END IF

	'' -------------------------------------------------------------
	'' Warn about PostScript fonts

	IF GetListItem( CHECKSTATES$, TYP1_FILES ) = "ON" THEN
		sz$ = UIStartDlg(CUIDLL$, TYP1_WARNING, "FInfoDlgProc", APPHELP, HELPPROC$)
		IF sz$ = "BACK" THEN
			UIPop 1
			GOTO CUSTINST
		ELSEIF sz$ = "EXIT" THEN
			UIPop 1
			GOSUB ASKQUIT
			GOTO CUSTINST
		ELSE
			UIPop 1
		END IF	
	END IF

'' ----------------------------------------------------------------
''	Warn User regarding Miracles

	IF ItsAMiracle% THEN 
		IF GetListItem( CHECKSTATES$, PPDRV_FILES ) = "ON" THEN
			sz$ = UIStartDlg(CUIDLL$, PPDRV_WARNING, "FInfoDlgProc", APPHELP, HELPPROC$)
			IF sz$ = "BACK" THEN
				UIPop 1
				GOTO CUSTINST
			ELSEIF sz$ = "EXIT" THEN
				UIPop 1
				GOSUB ASKQUIT
				GOTO CUSTINST
			ELSE
				UIPop 1
			END IF	
		END IF
	END IF


'' -----------------------------------------
''	Ready to go...
	UIPop 1			'' Pop off the CUSTINST dialog

'$IFDEF DEBUG
	x% = DoMsgBox( "Files are Copied Here", "DEBUG", 1 )
'$ELSE
    ClearCopyList
    AddOptFilesToCopyList PROG_FILES
    AddOptFilesToCopyList DVC_FILES
    AddOptFilesToCopyList SMPL_FILES
    AddOptFilesToCopyList TT_FILES
    AddOptFilesToCopyList TYP1_FILES

	IF ItsAMiracle% THEN 
		AddOptFilesToCopyList PPDRV_FILES
	END IF

    CreateDir DEST$, cmoNone
	SetRestartDir DEST$
    CopyFilesInCopyList
	
	
'$ENDIF		'' DEBUG

'' ----------------------------------
'' Setup the group and program items 
'' ----------------------------------
'$IFDEF DEMO
	GroupName$ = "Encore 3.0 Demo"
	ProgName$ = "Encore 3.0 Demo"
'$ELSE
	GroupName$ = "Encore 3.0"
	ProgName$ = "Encore 3.0"
'$ENDIF

    IF GetListItem(CHECKSTATES$, PROG_FILES) = "ON" THEN

'$IFDEF DEBUG
		x% = DoMsgBox( "Program Mgr Group and Files Created Here", "DEBUG", 1 )
		GOTO SAMPLE_ITEMS
'$ENDIF

		CreateProgmanGroup GroupName$, "", cmoNone
		ShowProgmanGroup  GroupName$, 1, cmoNone

'$IFDEF DEMO
		CreateProgmanItem GroupName$, ProgName$, MakePath(DEST$,"e30demo.exe"), "", cmoOverwrite
		CreateProgmanItem GroupName$, "Read Me", MakePath(DEST$,"readme.txt"), "", cmoOverwrite
'$ELSE
		CreateProgmanItem GroupName$, ProgName$, MakePath(DEST$,"encore30.exe"), "", cmoOverwrite

		ReplaceListItem NAMEORGIN$, 4, DEST$
		x% = GetCurrentInfo(1)

		szName$ = GetListItem( CONFIRM$, 1 )    '' name
		szOrg$ = GetListItem( CONFIRM$, 2 )     '' company
	    szSerial$ = GetListItem( CONFIRM$, 3 )      '' serial no
		szDat$ = CHR$( LEN(szName$) ) + szName$ + CHR$( LEN(szOrg$) ) + szOrg$ + CHR$( LEN(szSerial$) ) + szSerial$
		sz$ = GetListItem( NAMEORGIN$, 4 )      '' date/time of install directory
		szDat$ = szDat$ + CHR$( LEN( sz$ ) ) + sz$

		StampResource "ProgFiles", "Encore30", DEST$, 6, &H421, szDat$, LEN( szDat$ )

		sz$ = ""					    
		szDat$ = ""
		szName$ = ""    
		szOrg$ = ""
		szSerial$ = ""

		CreateProgmanItem GroupName$, "Encore Prefs", MakePath(DEST$, "Encore30.ini"), "", cmoOverwrite

'$ENDIF

    END IF

''--------------------------------------------------------
SAMPLE_ITEMS:
	IF GetListItem(CHECKSTATES$, SMPL_FILES) = "ON" THEN

'$IFDEF DEMO
		SampleDest$ = MakePath( DEST$, "e30demo.exe samples\" )
'$ELSE
		SampleDest$ = MakePath( DEST$, "encore30.exe samples\" )
'$ENDIF

		NumSamples% = GetListLength( SMPL_OPT$ )
		IF NumSamples% > 0 THEN
			FOR x% = 1 TO NumSamples%
				sz$ = GetListItem( SMPL_OPT$, x% )
				szf$ = GetSectionKeyFilename( "SampleFiles", sz$)

'$IFDEF DEBUG
				y% = DoMsgBox( "MakingItem: " + sz$ + CHR$(13) + CHR$(10) + MakePath(SampleDest$, szf$), "DEBUG", 1 )
'$ELSE
				IF sz$ = "Beethoven Example Notes" THEN
					CreateProgmanItem GroupName$, sz$, MakePath( DEST$, "samples\" + szf$), "", cmoOverwrite
				ELSE
				    CreateProgmanItem GroupName$, sz$, MakePath(SampleDest$, szf$), "", cmoOverwrite
				END IF
'$ENDIF

			NEXT x%
			sz$ = ""
			szf$ = ""
		END IF
		SampleDest$ = ""
	END IF

'' -----------------------------------------------------------------------------
''	Miracle MIDISet program

	IF ItsAMiracle% THEN
		IF GetListItem(CHECKSTATES$, PPDRV_FILES) = "ON" THEN

'$IFDEF DEBUG
			y% = DoMsgBox( "Adding MIDI Setup Item", "DEBUG", 1 )
'$ELSE
			CreateProgmanItem GroupName$, "MIDI Setup", MakePath(DEST$,"midiset.exe"), "", cmoOverwrite
'$ENDIF

		END IF 
	END IF

QUIT:
	ON ERROR GOTO ERRQUIT

    IF ERR = 0 THEN
		dlg% = EXITSUCCESS
    ELSEIF ERR = STFQUIT THEN
		dlg% = EXITQUIT
    ELSE
		dlg% = EXITFAILURE
    END IF

QUITL1:
    sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
		GOTO QUITL1
    END IF
    UIPop 1

    END

ERRQUIT:
	i% = DoMsgBox( "Encore 3.0 Setup Error:" + STR$(ERR) + CHR$(13) + CHR$(10) + ERROR$, "Encore Setup Abort", MB_OK+MB_TASKMODAL+MB_ICONHAND )
	END

GETPATH:
    SetSymbolValue "EditTextIn", DEST$
    SetSymbolValue "EditFocus", "END"
GETPATHL1:
    sz$ = UIStartDlg(CUIDLL$, DESTPATH, "FEditDlgProc", APPHELP, HELPPROC$)

    IF sz$ = "CONTINUE" THEN
		olddest$ = DEST$
		DEST$ = GetSymbolValue("EditTextOut")

		''Validate new path.  Disallow the root dir.
		IF IsDirWritable(DEST$) = 0 OR (LEN(DEST$) = 3 AND MID$(DEST$, 2, 2 ) = ":\" ) THEN
		    GOSUB BADPATH
	    	GOTO GETPATHL1
		END IF
		UIPop 1

		''Truncate display if too long.
		IF LEN(DEST$) > 23 THEN
	    	ReplaceListItem DRIVETEXT$, 7, MID$(DEST$, 1, 23)+"..."
		ELSE
		    ReplaceListItem DRIVETEXT$, 7, DEST$
		END IF

		''Recalc if path changed.
		IF (olddest$ <> DEST$) AND (olddest$ <> DEST$+"\") AND (olddest$+"\" <> DEST$) THEN
		    RecalcPath
		    SetDriveStatus
		END IF

		olddest$ = ""
		GOTO CUSTINST
    ELSEIF sz$ = "REACTIVATE" THEN
		RecalcPath
		SetDriveStatus
		GOTO GETPATHL1
    ELSEIF sz$ = "EXIT" THEN
		GOSUB ASKQUIT
		GOTO GETPATHL1
    ELSE
		UIPop 1
		GOTO CUSTINST
    END IF

'' Set the Path for TYPE1 fonts
TYPE1PATH:
    SetSymbolValue "EditTextIn", TYP1_DEST$
    SetSymbolValue "EditFocus", "END"
TYPE1PATHL1:
    sz$ = UIStartDlg(CUIDLL$, FONTPATH, "FEditDlgProc", APPHELP, HELPPROC$)

    IF sz$ = "CONTINUE" THEN
		olddest$ = TYP1_DEST$
		TYP1_DEST$ = GetSymbolValue("EditTextOut")

		''Validate new path. Disallow the root dir.
		IF IsDirWritable(TYP1_DEST$) = 0 OR (LEN(DEST$) = 3 AND MID$(DEST$, 2, 2 ) = ":\" ) THEN
	    	GOSUB BADPATH
			GOTO TYPE1PATHL1
		END IF
		UIPop 1

		''Truncate display if too long.
		IF LEN(TYP1_DEST$) > 23 THEN
		    ReplaceListItem DRIVETEXT$, 8, MID$(TYP1_DEST$, 1, 23)+"..."
		ELSE
		    ReplaceListItem DRIVETEXT$, 8, TYP1_DEST$
		END IF

		''Recalc if path changed.
		IF (olddest$ <> TYP1_DEST$) AND (olddest$ <> TYP1_DEST$+"\") AND (olddest$+"\" <> TYP1_DEST$) THEN
		    RecalcPath
		    SetDriveStatus
		END IF

		olddest$ = ""
		GOTO CUSTINST
    ELSEIF sz$ = "REACTIVATE" THEN
		RecalcPath
		SetDriveStatus
		GOTO TYPE1PATHL1
    ELSEIF sz$ = "EXIT" THEN
		GOSUB ASKQUIT
		GOTO TYPE1PATHL1
    ELSE
		UIPop 1
		GOTO CUSTINST
    END IF

SAMPLEFILES:
	MakeListFromSectionKeys  ALL_SMPL_OPT$, "SampleFiles"
	oldopt$ = GetSymbolValue( SMPL_OPT$ )
SMPLFILESL1:
	sz$ = UIStartDlg( CUIDLL$, SAMPLELIST, "FMultiDlgProc", APPHELP, HELPPROC$ )
	newopt$ = GetSymbolValue( SMPL_OPT$ ) 

	if sz$ = "CONTINUE" THEN
		UIPop 1
		IF newopt$ <> oldopt$ THEN
			RecalcOptFiles SMPL_FILES
			SetDriveStatus
		END IF
		newopt$ = ""
		oldopt$ = ""
		GOTO  CUSTINST
    ELSEIF sz$ = "REACTIVATE" THEN
		RecalcPath
		SetDriveStatus
		GOTO SMPLFILESL1
    ELSEIF sz$ = "EXIT" THEN
		GOSUB ASKQUIT
		GOTO SMPLFILESL1
    ELSE
		UIPop 1
		newopt$ = ""
		oldopt$ = ""
		GOTO CUSTINST
    END IF


TOOBIG:
    sz$ = UIStartDlg(CUIDLL$, TOOBIG, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
		RecalcPath
		SetDriveStatus
		GOTO TOOBIG
    END IF
    UIPop 1
    RETURN



BADPATH:
    sz$ = UIStartDlg(CUIDLL$, BADPATH, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
		RecalcPath
		SetDriveStatus
		GOTO BADPATH
    END IF
    	UIPop 1
    RETURN

BADSERIAL:
	x% = DoMsgBox( "Incorrect Serial Number.  Please Try Again.", "Encore 3.0 Setup", MB_OK+MB_ICONHAND )
	RETURN

ASKQUIT:
    sz$ = UIStartDlg(CUIDLL$, ASKQUIT, "FQuitDlgProc", 0, "")

    IF sz$ = "EXIT" THEN
		UIPopAll
		ERROR STFQUIT
    ELSEIF sz$ = "REACTIVATE" THEN
		GOTO ASKQUIT
    ELSE
		UIPop 1
    END IF

    RETURN

'**
'** Purpose:
'**     Adds the specified option files to the copy list.
'** Arguments:
'**     ftype%  - type of files to add, one of the following:
'**             PROG_FILES, DVC_FILES, etc.
'** Returns:
'**     none.
'*************************************************************************
SUB AddOptFilesToCopyList (ftype%) STATIC
	
    IF GetListItem(CHECKSTATES$, ftype%) = "ON" THEN
	    SrcDir$ = GetSymbolValue("STF_SRCDIR")
		IF ftype% = PROG_FILES THEN
	    	AddSectionFilesToCopyList "ProgFiles", SrcDir$, DEST$
			AddSectionFilesToCopyList "SysFiles", SrcDir$, GetWindowsSysDir
		ELSEIF ftype% = DVC_FILES THEN
			AddSectionFilesToCopyList "DvcFiles", SrcDir$, MakePath( DEST$, "DEVICES" )
		ELSEIF ftype% = SMPL_FILES THEN
			NumSamples% = GetListLength( SMPL_OPT$ )
			IF NumSamples% > 0 THEN
				FOR x% = 1 TO NumSamples%
					sz$ = GetListItem( SMPL_OPT$, x% )
				    AddSectionKeyFileToCopyList "SampleFiles", sz$, SrcDir$, MakePath( DEST$, "SAMPLES" )
				NEXT x%
				sz$ = ""
			END IF
		ELSEIF ftype% = TT_FILES THEN
			AddSectionFilesToCopyList "TrueTypeFiles", SrcDir$, DEST$
		ELSEIF ftype% = TYP1_FILES THEN
			AddSectionFilesToCopyList "Type1Files", SrcDir$, TYP1_DEST$
		ELSEIF ftype% = PPDRV_FILES THEN
			AddSectionFilesToCopyList "PassportDrivers", SrcDir$, DEST$
		END IF
		
	SrcDir$ = ""
	END IF
END SUB


'**
'** Purpose:
'**     Recalculates disk space for the given option files and sets
'**     the status info symbol "StatusItemsText".
'** Arguments:
'**     ftype% - type of files to add, one of the following:
'**             PROG_FILES, etc.
'** Returns:
'**     none.
'*************************************************************************
SUB RecalcOptFiles (ftype%) STATIC

    CursorSave% = ShowWaitCursor()
    ClearCopyList
    AddOptFilesToCopyList ftype%

    fExtra% = 0
    IF ftype% = PROG_FILES THEN
		ListSym$ = PROG_NEEDS$
		IF GetListItem(CHECKSTATES$, PROG_FILES) = "ON" THEN
		    ''Add extra cost to Windows drive for ini/progman, etc.
	    	ndrive% = ASC(ucase$(WINDRIVE$)) - ASC("A") + 1
		    ReplaceListItem EXTRACOSTS$, ndrive%, "10240"
		    fExtra% = 1
		END IF
    ELSEIF ftype% = DVC_FILES THEN
		ListSym$ = DVC_NEEDS$
    ELSEIF ftype% = SMPL_FILES THEN
		ListSym$ = SMPL_NEEDS$
	ELSEIF ftype% = TT_FILES THEN
		ListSym$ = TT_NEEDS$
	ELSEIF ftype% = TYP1_FILES THEN
		ListSym$ = TYP1_NEEDS$
	ELSEIF ftype% = PPDRV_FILES THEN
		ListSym$ = PPDRV_NEEDS$
    END IF

    StillNeed& = GetCopyListCost(EXTRACOSTS$, ListSym$, "")

    cost& = 0
    FOR i% = 1 TO 26 STEP 1
		cost&  = cost& + VAL(GetListItem(ListSym$, i%))
    NEXT i%

    ReplaceListItem STATUSTEXT$, ftype%, STR$(cost& / 1024) + " K"

    IF StillNeed& > 0 THEN
		ReplaceListItem BIGLIST$, ftype%, "YES"
    ELSE
		ReplaceListItem BIGLIST$, ftype%, ""
    END IF

    IF fExtra% THEN
		ReplaceListItem EXTRACOSTS$, ndrive%, "0"
    END IF
    RestoreCursor CursorSave%
    ListSym$ = ""
END SUB


'**
'** Purpose:
'**     Recalculates disk space and sets option status info according
'**     to the current destination path.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB RecalcPath STATIC

    CursorSave% = ShowWaitCursor()

    RecalcOptFiles PROG_FILES
    RecalcOptFiles DVC_FILES
    RecalcOptFiles SMPL_FILES
	RecalcOptFiles TT_FILES
	RecalcOptFiles TYP1_FILES

	IF ItsAMiracle% THEN
		RecalcOptFiles PPDRV_FILES
	END IF

    RestoreCursor CursorSave%
END SUB


'**
'** Purpose:
'**     Sets drive status info according to latest disk space calcs.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB SetDriveStatus STATIC

    drive$ = MID$(DEST$, 1, 1)
    ndrive% = ASC(ucase$(drive$)) - ASC("A") + 1

    cost& = VAL(GetListItem(PROG_NEEDS$, ndrive%)) + VAL(GetListItem(DVC_NEEDS$, ndrive%)) + VAL(GetListItem(SMPL_NEEDS$, ndrive%))
	cost& = cost& + VAL(GetListItem(TT_NEEDS$, ndrive%))  + VAL(GetListItem(TYP1_NEEDS$, ndrive%))

	IF ItsAMiracle% THEN
		cost& = cost& + VAL(GetListItem(PPDRV_NEEDS$, ndrive%))
	END IF

    free& = GetFreeSpaceForDrive(drive$)
    ReplaceListItem DRIVETEXT$, 1, drive$ + ":"
    ReplaceListItem DRIVETEXT$, 2, STR$(cost& / 1024) + " K"
    ReplaceListItem DRIVETEXT$, 3, STR$(free& / 1024) + " K"

    IF drive$ = WINDRIVE$ THEN
		ReplaceListItem DRIVETEXT$, 4, ""
		ReplaceListItem DRIVETEXT$, 5, ""
		ReplaceListItem DRIVETEXT$, 6, ""
    ELSE
		ndrive% = ASC(ucase$(WINDRIVE$)) - ASC("A") + 1

	    cost& = VAL(GetListItem(PROG_NEEDS$, ndrive%)) + VAL(GetListItem(DVC_NEEDS$, ndrive%)) + VAL(GetListItem(SMPL_NEEDS$, ndrive%))
		cost& = cost& + VAL(GetListItem(TT_NEEDS$, ndrive%)) + VAL(GetListItem(TYP1_NEEDS$, ndrive%))

		IF ItsAMiracle% THEN
			cost& = cost& + VAL(GetListItem(PPDRV_NEEDS$, ndrive%))
		END IF

		IF cost& = 0 THEN
		    ReplaceListItem DRIVETEXT$, 4, ""
		    ReplaceListItem DRIVETEXT$, 5, ""
		    ReplaceListItem DRIVETEXT$, 6, ""
		ELSE
		    free& = GetFreeSpaceForDrive(WINDRIVE$)
		    ReplaceListItem DRIVETEXT$, 4, WINDRIVE$ + ":"
		    ReplaceListItem DRIVETEXT$, 5, STR$(cost& / 1024) + " K"
		    ReplaceListItem DRIVETEXT$, 6, STR$(free& / 1024) + " K"
		END IF

'$IFDEF DEBUG
	y% = DoMsgBox( "Windrive Cost: " + str$( cost& ), "DEBUG", 1 )
'$ENDIF

    END IF
END SUB


'**
'** Purpose:
'**     Appends a file name to the end of a directory path,
'**     inserting a backslash character as needed.
'** Arguments:
'**     szDir$  - full directory path (with optional ending "\")
'**     szFile$ - filename to append to directory
'** Returns:
'**     Resulting fully qualified path name.
'*************************************************************************
FUNCTION MakePath (szDir$, szFile$) STATIC AS STRING
    IF szDir$ = "" THEN
	MakePath = szFile$
    ELSEIF szFile$ = "" THEN
	MakePath = szDir$
    ELSEIF MID$(szDir$, LEN(szDir$), 1) = "\" THEN
	MakePath = szDir$ + szFile$
    ELSE
	MakePath = szDir$ + "\" + szFile$
    END IF
END FUNCTION

'**
'** Purpose:
'**     Validate a serial number
'** Arguments:
'**     szSerial$  - The number to validate
'** Returns:
'**     -1 if OK, 0 if invalid
'*************************************************************************
FUNCTION ValidSerialNo( szSerial$ ) STATIC AS INTEGER

	ValidSerialNo = -1      '' Assume it's OK
	IF AlreadyInstalled% AND szSerial$ <> OrigSerial$ THEN
		ValidSerialNo = 0
	ELSEIF LEN( szSerial$ ) <> 17  OR  MID$( szSerial$, 1 , 5 ) <> "EV30-" OR MID$( szSerial$, 7 , 7 ) <> "-02032-" THEN
		ValidSerialNo = 0
	END IF

END FUNCTION

'**
'** Purpose:
'**     Check Write Protection Status of Source Drive
'** Arguments:
'**     szPath$  - The source path
'** Returns:
'**     -1 if WriteProtected, 0 if not
'*************************************************************************
FUNCTION IsWriteProtected(  ) STATIC AS INTEGER

	IsWriteProtected = 0		'' Assume OK

'$IFDEF DEBUG
	szCheckPath$ = "B:\XXX.TST"
'$ELSE
	szCheckPath$ = MakePath( GetSymbolValue( "STF_SRCDIR" ), "XXX.TST" )
'$ENDIF

	ERR = 0
	OPEN szCheckPath$ FOR OUTPUT AS #1
	
	IF ERR THEN 
		IsWriteProtected = -1
	ELSE
		CLOSE #1
		KILL szCheckPath$
	END IF
	ERR = 0

END FUNCTION

